package com.swiftcleaner.chovey.view.activity;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.widget.AppCompatButton;
import androidx.cardview.widget.CardView;
import androidx.core.app.ActivityCompat;
import androidx.core.content.ContextCompat;
import androidx.recyclerview.widget.GridLayoutManager;

import android.Manifest;
import android.animation.ValueAnimator;
import android.app.Activity;
import android.app.Dialog;
import android.content.ActivityNotFoundException;
import android.content.Context;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.graphics.Color;
import android.net.Uri;
import android.os.Build;
import android.os.CountDownTimer;
import android.os.Environment;
import android.provider.Settings;
import android.util.Log;
import android.view.View;
import android.widget.Toast;

import com.gyf.immersionbar.ImmersionBar;
import com.swiftcleaner.chovey.R;
import com.swiftcleaner.chovey.business.EventUtils;
import com.swiftcleaner.chovey.business.admob.AdmobManager;
import com.swiftcleaner.chovey.databinding.ActivityScreenShotBinding;
import com.swiftcleaner.chovey.model.bean.CleanFileBean;
import com.swiftcleaner.chovey.model.tool.FileHelps;
import com.swiftcleaner.chovey.model.tool.MediaHelps;
import com.swiftcleaner.chovey.model.tool.ToastUtil;
import com.swiftcleaner.chovey.model.util.AppSchedulers;
import com.swiftcleaner.chovey.model.util.FinishMain;
import com.swiftcleaner.chovey.view.BaseActivity;
import com.swiftcleaner.chovey.view.BaseActivityKotlin;
import com.swiftcleaner.chovey.view.MainActivity;
import com.swiftcleaner.chovey.view.adapter.ScreenShotAdapter;
import com.swiftcleaner.chovey.view.dialog.CustomScoreDialog;
import com.swiftcleaner.chovey.view.dialog.LoadingDialog;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import io.reactivex.rxjava3.core.Observable;
import io.reactivex.rxjava3.disposables.CompositeDisposable;
import io.reactivex.rxjava3.disposables.Disposable;

public class ScreenShotActivity extends BaseActivity<ActivityScreenShotBinding> {
    private ScreenShotAdapter screenShotAdapter;
    private List<CleanFileBean> cleanFileBeans;
    private CompositeDisposable compositeDisposable = new CompositeDisposable();
    private long wasteNumber = 0;
    private long selectedSize = 0;
    private ValueAnimator animator;
    private CountDownTimer countDownTimer;
    private static final int REQUEST_ALL_FILES_ACCESS_PERMISSION = 100;
    private static final int REQUEST_PERMISSION_CODE = 101;
    @Override
    protected ActivityScreenShotBinding getViewBinding() {
        return ActivityScreenShotBinding.inflate(getLayoutInflater());
    }

    @Override
    protected void initView() {
        initBar();
    }

    @Override
    protected void initData() {
        EventUtils.INSTANCE.event("page_ScreenShotActivity", "", null);
        initPage();
        initShow();
    }
    private void initPage() {
        binding.clRadarview.setVisibility(View.VISIBLE);
        binding.radarview.setSearching(true);
        AdmobManager.INSTANCE.showNativeAd(ScreenShotActivity.this, (nativeAd) -> {
            binding.flAdDonghua.removeAllViews();
            binding.flAdDonghua.setNativeAd(nativeAd, R.layout.layout_ad_native);
            return null;
        }, null, null);
        initAnimotorPer();
        countDownTimer = new CountDownTimer(5000, 1000) {
            @Override
            public void onTick(long millisUntilFinished) {
            }

            @Override
            public void onFinish() {
                binding.radarview.setSearching(false);
                countDownTimer.cancel();
                animator.cancel();
                binding.clRadarview.setVisibility(View.GONE);
                LoadingDialog loadingDialog = new LoadingDialog(ScreenShotActivity.this);
                loadingDialog.show();
                if (AdmobManager.INSTANCE.isShowAdInter()){
                    AdmobManager.INSTANCE.showInterstitialAd(ScreenShotActivity.this, () -> {
                                return null;
                            },
                            () -> {
                                checkAndRequestPermissions();
                                binding.flAdDonghua.removeAllViews();
                                loadingDialog.dismiss();
                                return null;
                            },
                            () -> {
                                checkAndRequestPermissions();
                                loadingDialog.dismiss();
                                binding.flAdDonghua.removeAllViews();
                                return null;
                            }, false);
                }else {
                    checkAndRequestPermissions();
                    loadingDialog.dismiss();
                }
            }
        }.start();
        AdmobManager.INSTANCE.showNativeAd(ScreenShotActivity.this, (nativeAd) -> {
            binding.flAd.removeAllViews();
            binding.flAd.setNativeAd(nativeAd, R.layout.layout_ad_native);
            return null;
        }, null, null);

    }
    private void checkAndRequestPermissions() {
        if (!checkFilesAccessPermission(this)) {
            // 没有权限，请求权限
            requestFilesAccessPermission();
        }
    }

    private boolean checkFilesAccessPermission(Context context) {
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.R) {
            return Environment.isExternalStorageManager();
        } else {
            int readPermission = ContextCompat.checkSelfPermission(context, Manifest.permission.READ_EXTERNAL_STORAGE);
            int writePermission = ContextCompat.checkSelfPermission(context, Manifest.permission.WRITE_EXTERNAL_STORAGE);
            return readPermission == PackageManager.PERMISSION_GRANTED && writePermission == PackageManager.PERMISSION_GRANTED;
        }
    }

    private void requestFilesAccessPermission() {
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.R) {
            try {
                Intent intent = new Intent(Settings.ACTION_MANAGE_APP_ALL_FILES_ACCESS_PERMISSION);
                intent.addCategory("android.intent.category.DEFAULT");
                intent.setData(Uri.parse("package:" + getPackageName()));
                startActivityForResult(intent, REQUEST_ALL_FILES_ACCESS_PERMISSION);
            } catch (ActivityNotFoundException e) {
                Toast.makeText(this, "Unable to request permission, please grant manually", Toast.LENGTH_SHORT).show();
            }
        } else {
            ActivityCompat.requestPermissions(this, new String[]{Manifest.permission.READ_EXTERNAL_STORAGE, Manifest.permission.WRITE_EXTERNAL_STORAGE}, REQUEST_PERMISSION_CODE);
        }
    }

    @Override
    public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults);
        if (requestCode == REQUEST_ALL_FILES_ACCESS_PERMISSION) {
            if (!checkFilesAccessPermission(this)) {
                // 权限未授予，直接关闭页面
                Toast.makeText(this, "Unauthorized permission, the page is about to close", Toast.LENGTH_SHORT).show();
                finish();
            }
        } else if (requestCode == REQUEST_PERMISSION_CODE) {
            if (grantResults.length > 0 && grantResults[0] == PackageManager.PERMISSION_GRANTED && grantResults[1] == PackageManager.PERMISSION_GRANTED) {
                // 权限已授予，可以继续操作
            } else {
                // 权限未授予，直接关闭页面
                Toast.makeText(this, "Unauthorized permission, the page is about to close", Toast.LENGTH_SHORT).show();
                finish();
            }
        }
    }
    private void initShow() {
        binding.ivReturn.setOnClickListener(v -> {
            initCustDialog();
        });
        binding.buttonScreenshotDelete.setOnClickListener(v -> {
            if (selectedSize == 0) {
                ToastUtil.showLongToast(this, "Please check the file to be deleted");
            } else {
                showCustomDialog();
            }
        });
        Disposable disposable = Observable.fromCallable(() -> {
                    Map<String, List<CleanFileBean>> screenshotsMap = MediaHelps.findScreenshotsFiles(this);
                    cleanFileBeans = new ArrayList<>(screenshotsMap.values().size());

                    for (List<CleanFileBean> files : screenshotsMap.values()) {
                        for (CleanFileBean file : files) {
                            cleanFileBeans.add(file);
                            wasteNumber += file.getLength();
                        }
                    }
                    return cleanFileBeans;
                }).subscribeOn(AppSchedulers.io())
                .observeOn(AppSchedulers.mainThread())
                .subscribe(emptyFolders -> {
                    binding.tvLoad.setVisibility(View.GONE);
                    screenShotAdapter = new ScreenShotAdapter(cleanFileBeans, (fileBean) -> {
                        if (fileBean.isSelected()) {
                            selectedSize += fileBean.getLength();
                            updateDeleteButton();
                        } else {
                            selectedSize -= fileBean.getLength();
                            updateDeleteButton();
                        }
                    });
                    binding.screenshotRecy.setLayoutManager(new GridLayoutManager(this, 3));
                    binding.screenshotRecy.setAdapter(screenShotAdapter);
                    binding.wasteNumber.setText(formatFileSize(wasteNumber));
                }, throwable -> {
                    // 处理错误
                    throwable.printStackTrace();
                });
        compositeDisposable.add(disposable);
    }

    private void updateDeleteButton() {
        binding.buttonScreenshotDelete.setText("Delete " + formatFileSize(selectedSize));
        if (selectedSize == 0) {
            binding.buttonScreenshotDelete.setBackground(ContextCompat.getDrawable(this, R.drawable.shape_radio_80dp_hui_se));
        } else {
            binding.buttonScreenshotDelete.setBackground(ContextCompat.getDrawable(this, R.drawable.shape_clean_up));
        }
    }

    private void showCustomDialog() {
        Dialog dialog = new Dialog(this, R.style.TransparentDialogTheme);
        dialog.setContentView(R.layout.dialog_delete);

        AppCompatButton dialogDeleteCancel = dialog.findViewById(R.id.dialog_delete_cancel);
        AppCompatButton dialogDeleteOk = dialog.findViewById(R.id.dialog_delete_ok);

        CardView cardView = dialog.findViewById(R.id.cardview);
        cardView.setCardBackgroundColor(Color.TRANSPARENT);

        dialogDeleteCancel.setOnClickListener(v -> dialog.dismiss());
        dialogDeleteOk.setOnClickListener(v -> {
            List<CleanFileBean> selectedFiles = screenShotAdapter.getSelectedFiles();
            cleanFiles(selectedFiles);
            dialog.dismiss();
            //跳转
            initAnimation(formatFileSize(selectedSize));
        });

        dialog.setCanceledOnTouchOutside(false);
        dialog.show();
    }

    private void cleanFiles(List<CleanFileBean> selectedFiles) {
        Disposable disposable = Observable.fromCallable(() -> {
                    // 文件删除操作，放到后台线程执行
                    for (CleanFileBean fileBean : selectedFiles) {
                        FileHelps.deleteFile(fileBean.getPath());
                        Log.d("deleteFile",fileBean.getPath());
                    }

                    // 将删除的文件路径转换为数组
                    String[] paths = selectedFiles.stream()
                            .map(CleanFileBean::getPath)
                            .toArray(String[]::new);
                    return paths;
                })
                .subscribeOn(AppSchedulers.io()) // 在后台线程执行文件删除
                .observeOn(AppSchedulers.mainThread()) // 切换到主线程执行 UI 更新
                .subscribe(paths -> {
                    // 更新媒体库
                    MediaHelps.updateMedia(getApplication(), paths);
                    screenShotAdapter.removeSelectedFiles(selectedFiles);
                    screenShotAdapter.notifyDataSetChanged();
                    selectedSize = 0;
                    updateDeleteButton();
                }, throwable -> {
                    // 处理错误
                    throwable.printStackTrace();
                });
        compositeDisposable.add(disposable);
    }
    private void initAnimotorPer(){
        // 创建ValueAnimator，从1到100
        animator = ValueAnimator.ofInt(1, 100);
        animator.setDuration(5000); // 3秒

        // 设置更新监听器，每帧更新进度文本
        animator.addUpdateListener(new ValueAnimator.AnimatorUpdateListener() {
            @Override
            public void onAnimationUpdate(ValueAnimator animation) {
                int currentValue = (int) animation.getAnimatedValue();
                binding.parText.setText(currentValue + "%");
            }
        });
        // 开始动画
        animator.start();
    }
    private void initAnimation(String cleanSize) {
        Intent intent = new Intent(this, EndCleanJunkActivity.class);
        intent.putExtra("cleanstr", cleanSize);
        startActivity(intent);
        finish();
    }
    @Override
    protected void onActivityResult(int requestCode, int resultCode, @Nullable Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (requestCode == REQUEST_ALL_FILES_ACCESS_PERMISSION) {
            // 检查权限是否已经授予
            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.R) {
                if (Environment.isExternalStorageManager()) {
                    // 权限已授予，刷新页面或执行相关操作
                    Intent intent = new Intent(this, MainActivity.class);
                    startActivity(intent);
                    finish();
                } else {
                    // 权限未授予，提示用户
                    Toast.makeText(this, "Permission not granted, please grant manually", Toast.LENGTH_SHORT).show();
                }
            }
        }
    }
    private String formatFileSize(long size) {
        if (size <= 0) return "0 Bytes";
        final String[] units = new String[]{"Bytes", "KB", "MB", "GB", "TB"};
        int digitGroups = (int) (Math.log10(size) / Math.log10(1024));
        return new DecimalFormat("#,##0.#").format(size / Math.pow(1024, digitGroups)) + " " + units[digitGroups];
    }

    private void initBar() {
        ImmersionBar.with(this)
                .transparentStatusBar()  // 透明状态栏
                .statusBarDarkFont(false)  // 状态栏字体颜色为浅色
                .navigationBarDarkIcon(true)  // 导航栏图标颜色为浅色
                .init();
    }

    @Override
    public void onBackPressed() {
        initCustDialog();
    }

    private void initCustDialog() {
        Activity activity = this;
        CustomScoreDialog customScoreDialog = new CustomScoreDialog(this);
        customScoreDialog.setOnDialogClickListener(new CustomScoreDialog.OnDialogClickListener() {
            @Override
            public void onCancel() {
                customScoreDialog.dismiss();
            }

            @Override
            public void onSubmit() {
                if (AdmobManager.INSTANCE.isShowAdBackInter()){
                    AdmobManager.INSTANCE.showInterstitialAd(ScreenShotActivity.this, () -> {
                                FinishMain.INSTANCE.finishToMain(activity);
                                return null;
                            },
                            () -> {
                                return null;
                            },
                            () -> {
                                FinishMain.INSTANCE.finishToMain(activity);
                                return null;
                            },false);
                }else {
                    finish();
                }

            }
        });
        customScoreDialog.show();
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        compositeDisposable.clear();
        if (countDownTimer!=null){
            countDownTimer.cancel();
        }
        if (animator!=null){
            animator.cancel();
        }
    }
}